"use strict";

function _typeof2(obj) { "@babel/helpers - typeof"; return _typeof2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof2(obj); }

/**
 * Main Smart WooCommerce Wishlist JS
 *
 * @author MoreConvert
 * @package Smart Wishlist For More Convert
 *
 * @version 1.4.0
 */

/*jshint esversion: 6 */
(function ($) {
  $.noConflict();
  $(document).ready(function () {
    /* === MAIN INIT === */
    var product_in_list = [],
        lang = wlfmc_l10n.lang,
        wishlist_items = wlfmc_l10n.wishlist_items;
    $(document).on('wlfmc_init', function () {
      init_fix_on_image_single_position();
      var t = $(this),
          cart_redirect_after_add = typeof wc_add_to_cart_params !== 'undefined' && wc_add_to_cart_params !== null ? wc_add_to_cart_params.cart_redirect_after_add : '';
      t.on('click', '.wlfmc_add_to_wishlist', function (ev) {
        var t = $(this),
            product_id = t.attr('data-product-id'),
            el_wrap = t.closest('.wlfmc-add-to-wishlist-' + product_id),
            filtered_data = null,
            data = {
          action: wlfmc_l10n.actions.add_to_wishlist_action,
          context: 'frontend',
          add_to_wishlist: product_id,
          product_type: t.data('product-type'),
          wishlist_id: t.attr('data-wishlist-id'),
          fragments: retrieve_fragments(product_id)
        }; // allow third party code to filter data.

        if (filtered_data === $(document).triggerHandler('wlfmc_add_to_wishlist_data', [t, data])) {
          data = filtered_data;
        }

        ev.preventDefault();
        jQuery(document.body).trigger('wlfmc_adding_to_wishlist');

        if (!is_cookie_enabled()) {
          window.alert(wlfmc_l10n.labels.cookie_disabled);
          return;
        }

        $.ajax({
          type: 'POST',
          url: wlfmc_l10n.ajax_url,
          data: data,
          dataType: 'json',
          beforeSend: function beforeSend(xhr) {
            if (wlfmc_l10n.ajax_mode === 'rest_api') {
              xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
            }

            block(t);
          },
          complete: function complete() {
            unblock(t);
          },
          success: function success(response) {
            var response_result = response.result,
                response_message = response.message,
                show_toast = true;

            if (response_result === 'true' || response_result === 'exists') {
              if (typeof response.fragments !== 'undefined') {
                replace_fragments(response.fragments);
              }

              if (response.item_id) {
                if (typeof product_in_list !== 'undefined' && product_in_list !== null) {
                  product_in_list.push({
                    wishlist_id: response.wishlist_id,
                    item_id: response.item_id,
                    product_id: parseInt(product_id)
                  });
                  set_products_hash(JSON.stringify(product_in_list));
                }
              }

              var popup_id = el_wrap.attr('data-popup-id');

              if (popup_id) {
                show_toast = false;
                var popup = $('#' + popup_id).popup({
                  closeelement: '#' + popup_id + '_close',
                  absolute: false,
                  color: '#fff',
                  horizontal: $('#' + popup_id).data('horizontal'),
                  vertical: $('#' + popup_id).data('vertical'),
                  transition: 'all 0.3s'
                });
                popup.popup('show');
              }

              if (show_toast && '' !== $.trim(wlfmc_l10n.labels.product_added_text) && response_result === 'true') {
                toastr.success(wlfmc_l10n.labels.product_added_text);
              }

              if (response_result === 'true') {
                load_analytics(parseInt(product_id), response.wishlist_id);
              }
            }

            if (response_result === 'true' && wlfmc_l10n.click_behavior === 'add-redirect') {
              window.location.href = response.wishlist_url;
            }

            if (show_toast && '' !== $.trim(response.message) && response_result !== 'true') {
              toastr.error(response_message);
            }

            init_handling_after_ajax();
            $('body').trigger('wlfmc_added_to_wishlist', [t, el_wrap]);
          }
        });
        return false;
      });
      t.on('click', '.wlfmc-btn-login-need', function (ev) {
        ev.preventDefault();
        toastr.error(wlfmc_l10n.labels.login_need);
        return false;
      });
      t.on('click', '.wlfmc_already_in_wishlist', function (ev) {
        ev.preventDefault();
        toastr.error(wlfmc_l10n.labels.already_in_wishlist_text);
        return false;
      });
      t.on('click', '.wlfmc-wishlist-table .remove_from_wishlist', function (ev) {
        var t = $(this);
        ev.preventDefault();
        var table = t.parents('.wlfmc-wishlist-items-wrapper'),
            row = t.parents('[data-row-id]'),
            data_row_id = row.data('row-id'),
            wishlist_id = table.data('id'),
            wishlist_token = table.data('token'),
            data = {
          action: wlfmc_l10n.actions.remove_from_wishlist_action,
          context: 'frontend',
          remove_from_wishlist: data_row_id,
          wishlist_id: wishlist_id,
          wishlist_token: wishlist_token,
          fragments: retrieve_fragments(data_row_id)
        };
        $.ajax({
          beforeSend: function beforeSend(xhr) {
            if (wlfmc_l10n.ajax_mode === 'rest_api') {
              xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
            }

            block(row);
          },
          complete: function complete() {
            unblock(row);
          },
          data: data,
          method: 'post',
          success: function success(data) {
            if (typeof data.fragments !== 'undefined') {
              replace_fragments(data.fragments);
            }

            if ('true' == data.result) {
              if (typeof product_in_list !== 'undefined' && product_in_list !== null) {
                var product_count = product_in_list.length;

                for (var i = 0; i <= product_count - 1; i++) {
                  if (typeof product_in_list[i] !== 'undefined' && product_in_list[i].wishlist_id == wishlist_id && product_in_list[i].product_id == data_row_id) {
                    product_in_list.splice(i, 1);
                    break;
                  }
                }

                set_products_hash(JSON.stringify(product_in_list));
              }
            }

            init_handling_after_ajax();
            $('body').trigger('wlfmc_removed_from_wishlist', [t, row, data]);
          },
          url: wlfmc_l10n.ajax_url
        });
        return false;
      });
      t.on('click', '.wlfmc-products-counter-wishlist .remove_from_wishlist', function (ev) {
        var t = $(this);
        ev.preventDefault();
        var table = t.parents('.wlfmc-wishlist-items-wrapper'),
            row = t.parents('[data-row-id]'),
            data_row_id = row.data('row-id'),
            wishlist_id = table.data('id'),
            wishlist_token = table.data('token'),
            data = {
          action: wlfmc_l10n.actions.remove_from_wishlist_action,
          context: 'frontend',
          remove_from_wishlist: data_row_id,
          wishlist_id: wishlist_id,
          wishlist_token: wishlist_token,
          fragments: retrieve_fragments(data_row_id)
        };
        $.ajax({
          beforeSend: function beforeSend(xhr) {
            if (wlfmc_l10n.ajax_mode === 'rest_api') {
              xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
            }

            block(table);
          },
          complete: function complete() {
            unblock(table);
          },
          data: data,
          method: 'post',
          success: function success(data) {
            if ('true' == data.result) {
              if (typeof product_in_list !== 'undefined' && product_in_list !== null) {
                var product_count = product_in_list.length;

                for (var i = 0; i <= product_count - 1; i++) {
                  if (typeof product_in_list[i] !== 'undefined' && product_in_list[i].wishlist_id === wishlist_id && product_in_list[i].product_id === data_row_id) {
                    product_in_list.splice(i, 1);
                    break;
                  }
                }

                set_products_hash(JSON.stringify(product_in_list));
              }

              $('.wlfmc-products-counter-wrapper').find('[data-row-id="' + data_row_id + '"]').remove();
              $('.wlfmc-wishlist-form').find('[data-row-id="' + data_row_id + '"]').remove();
              $('.wlfmc-products-counter-wrapper  .products-counter-number').text(data.count);
              $('.wlfmc-products-counter-wishlist .total-products .wlfmc-total-count').text(data.count);
              $('.wlfmc-add-to-wishlist.wlfmc-add-to-wishlist-' + data_row_id).removeClass('exists');

              if ((data.count < 1 || !table.find('[data-row-id]').length) && typeof data.fragments !== 'undefined') {
                replace_fragments(data.fragments);
              }
            }

            init_handling_after_ajax();
            $('body').trigger('wlfmc_removed_from_wishlist', [t, row, data]);
          },
          url: wlfmc_l10n.ajax_url
        });
        return false;
      });
      t.on('adding_to_cart', 'body', function (ev, button, data) {
        if (typeof button !== 'undefined' && typeof data !== 'undefined' && button.closest('.wlfmc-wishlist-table').length) {
          data.remove_from_wishlist_after_add_to_cart = button.closest('[data-row-id]').data('row-id');
          data.wishlist_id = button.closest('.wlfmc-wishlist-table').data('id');
        }
      });
      t.on('added_to_cart', 'body', function (ev, fragments, carthash, button) {
        if (typeof button !== 'undefined' && button.closest('.wlfmc-wishlist-table').length) {
          var tr = button.closest('[data-row-id]'),
              table = tr.closest('.wlfmc-wishlist-fragment'),
              options = table.data('fragment-options'),
              data_row_id = tr.data('row-id'),
              wishlist_id = table.data('id'),
              wishlist_token = table.data('token');
          button.removeClass('added');
          tr.find('.added_to_cart').remove();

          if (wlfmc_l10n.remove_from_wishlist_after_add_to_cart && options.is_user_owner) {
            if (typeof product_in_list !== 'undefined' && product_in_list !== null) {
              var product_count = product_in_list.length;

              for (var i = 0; i <= product_count - 1; i++) {
                if (typeof product_in_list[i] !== 'undefined' && product_in_list[i].wishlist_id == wishlist_id && product_in_list[i].product_id == data_row_id) {
                  product_in_list.splice(i, 1);
                }
              }

              set_products_hash(JSON.stringify(product_in_list));
            }
          }
        }
      });
      t.on('added_to_cart', 'body', function () {
        var messages = $('.woocommerce-message');

        if (messages.length === 0) {
          $('#wlfmc-wishlist-form').prepend(wlfmc_l10n.labels.added_to_cart_message);
        } else {
          messages.fadeOut(300, function () {
            $(this).replaceWith(wlfmc_l10n.labels.added_to_cart_message).fadeIn();
          });
        }
      });
      t.on('cart_page_refreshed', 'body', init_handling_after_ajax);
      t.on('click', '.wlfmc_delete_item', function () {
        var t = $(this),
            product_id = t.attr('data-product-id'),
            wishlist_id = t.attr('data-wishlist-id'),
            item_id = t.attr('data-item-id'),
            el_wrap = $('.wlfmc-add-to-wishlist-' + product_id),
            data = {
          action: wlfmc_l10n.actions.delete_item_action,
          context: 'frontend',
          wishlist_id: wishlist_id,
          item_id: item_id,
          fragments: retrieve_fragments(product_id)
        };
        $.ajax({
          url: wlfmc_l10n.ajax_url,
          data: data,
          dataType: 'json',
          beforeSend: function beforeSend(xhr) {
            if (wlfmc_l10n.ajax_mode === 'rest_api') {
              xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
            }

            block(t);
          },
          complete: function complete() {
            unblock(t);
          },
          method: 'post',
          success: function success(response) {
            var fragments = response.fragments,
                response_message = response.message;

            if ('true' === response.result) {
              el_wrap.removeClass('exists');

              if (typeof product_in_list !== 'undefined' && product_in_list !== null) {
                product_in_list = $.grep(product_in_list, function (e) {
                  return e.item_id !== parseInt(item_id);
                });
                set_products_hash(JSON.stringify(product_in_list));
              }
            }

            if (!t.closest('.wlfmc-remove-button').length && '' !== $.trim(response_message)) {
              toastr.error(response_message);
            }

            if ('true' === response.result && '' !== $.trim(wlfmc_l10n.labels.product_removed_text)) {
              toastr.error(wlfmc_l10n.labels.product_removed_text);
            }

            if (typeof fragments !== 'undefined') {
              replace_fragments(fragments);
            }

            init_handling_after_ajax();
            $('body').trigger('wlfmc_removed_from_wishlist', [t, el_wrap, response]);
          }
        });
        return false;
      });
      t.on('change', '#bulk_add_to_cart', function () {
        var t = $(this),
            checkboxes = t.closest('.wlfmc-wishlist-table').find('[data-row-id]').find('input[type="checkbox"]:not(:disabled)');

        if (t.is(':checked')) {
          checkboxes.prop('checked', 'checked').trigger('change');
        } else {
          checkboxes.prop('checked', false).trigger('change');
        }
      });
      t.on('submit', '.wlfmc-popup-form', function () {
        return false;
      });
      t.on('found_variation', function (ev, variation) {
        var t = $(ev.target),
            product_id = t.data('product_id'),
            variation_id = variation.variation_id,
            targets = $('.wlfmc-add-to-wishlist [data-parent-product-id="' + product_id + '"]'),
            enable_outofstock = targets.closest('.wlfmc-add-to-wishlist').data('enable-outofstock');

        if (!product_id || !variation_id || !targets.length) {
          return;
        }

        if (!enable_outofstock && !variation.is_in_stock) {
          targets.closest('.wlfmc-add-to-wishlist').addClass('hide');
        } else {
          targets.closest('.wlfmc-add-to-wishlist').removeClass('hide');
        }

        var popup = $('#' + targets.closest('.wlfmc-add-to-wishlist').attr('data-popup-id'));

        if (popup.length) {
          var product_title = popup.data('product-title');
          var desc = wlfmc_l10n.labels.popup_content;
          var title = wlfmc_l10n.labels.popup_title;
          var image_size = popup.data('image-size');
          var img = popup.find('.wlfmc-popup-header img').data('src');
          var original_price = popup.find('.wlfmc-parent-product-price').html();
          var product_price = '' !== variation.price_html ? variation.price_html : original_price;
          desc = desc.replace('{product_price}', product_price);
          desc = desc.replace('{product_name}', product_title);
          title = title.replace('{product_price}', product_price);
          title = title.replace('{product_name}', product_title);

          if (variation.image_id && 'true' == popup.data('use-featured')) {
            img = 'large' === image_size ? variation.image.full_src : 'thumbnail' === image_size ? variation.image.thumb_src : variation.image.src;
          }

          popup.find('.wlfmc-popup-title').html(title);
          popup.find('.wlfmc-popup-desc').html(desc);
          popup.find('.wlfmc-popup-header img').attr('src', img);
        }

        targets.each(function () {
          var t = $(this),
              container = t.closest('.wlfmc-add-to-wishlist');
          t.attr('data-parent-product-id', product_id);
          t.attr('data-product-id', variation_id);

          if (container.length) {
            container.removeClass(function (i, classes) {
              return classes.match(/wlfmc-add-to-wishlist-\S+/g).join(' ');
            }).addClass('wlfmc-add-to-wishlist-' + variation_id).removeClass('exists');
          }

          container.find('.wlfmc-addtowishlist a').attr('href', container.attr('data-add-url').replace("#product_id", variation_id));
          container.find('.wlfmc-removefromwishlist a').attr('href', container.attr('data-remove-url').replace("#product_id", variation_id));
          $.each(product_in_list, function (i, v) {
            if (typeof v !== 'undefined' && v.product_id && v.product_id == variation_id) {
              container.addClass('exists');
              container.find('.wlfmc_delete_item').attr('data-wishlist-id', v.wishlist_id);
              container.find('.wlfmc_delete_item').attr('data-item-id', v.item_id);
            }
          });
        });
      });
      t.on('reset_data', function (ev) {
        var t = $(ev.target),
            product_id = t.data('product_id'),
            targets = $('.wlfmc-add-to-wishlist [data-parent-product-id="' + product_id + '"]');

        if (!product_id || !targets.length) {
          return;
        }

        targets.closest('.wlfmc-add-to-wishlist').removeClass('hide');
        var popup = $('#' + targets.closest('.wlfmc-add-to-wishlist').attr('data-popup-id'));

        if (popup.length) {
          var original_price = popup.find('.wlfmc-parent-product-price').html();
          var product_title = popup.data('product-title');
          var desc = wlfmc_l10n.labels.popup_content;
          var title = wlfmc_l10n.labels.popup_title;
          var img = popup.find('.wlfmc-popup-header img').data('src');
          desc = desc.replace('{product_price}', original_price);
          desc = desc.replace('{product_name}', product_title);
          title = title.replace('{product_price}', original_price);
          title = title.replace('{product_name}', product_title);
          popup.find('.wlfmc-popup-title').html(title);
          popup.find('.wlfmc-popup-desc').html(desc);
          popup.find('.wlfmc-popup-header img').attr('src', img);
        }

        targets.each(function () {
          var t = $(this),
              container = t.closest('.wlfmc-add-to-wishlist');
          t.attr('data-parent-product-id', product_id);
          t.attr('data-product-id', product_id);

          if (container.length) {
            container.removeClass(function (i, classes) {
              return classes.match(/wlfmc-add-to-wishlist-\S+/g).join(' ');
            }).addClass('wlfmc-add-to-wishlist-' + product_id).removeClass('exists');
          }

          container.find('.wlfmc-addtowishlist a').attr('href', container.attr('data-add-url').replace("#product_id", product_id));
          container.find('.wlfmc-removefromwishlist a').attr('href', container.attr('data-remove-url').replace("#product_id", product_id));
          $.each(product_in_list, function (i, v) {
            if (typeof v !== 'undefined' && v.product_id && v.product_id == product_id) {
              container.addClass('exists');
              container.find('.wlfmc_delete_item').attr('data-wishlist-id', v.wishlist_id);
              container.find('.wlfmc_delete_item').attr('data-item-id', v.item_id);
            }
          });
        });
      });
      t.on('wlfmc_reload_fragments', load_fragments);
      t.on('wlfmc_fragments_loaded', function (ev, original, update, firstLoad) {
        if (!firstLoad) {
          return;
        }

        $('.variations_form').find('.variations select').last().trigger('change');
      });
      t.on('click', '.wlfmc-products-counter-wrapper.show-list-on-click .wlfmc-products-counter.has-dropdown', function (ev) {
        ev.preventDefault();
        var elem = $(this).closest('.wlfmc-products-counter-wrapper').find('.wlfmc-products-counter-dropdown');
        prepare_mini_wishlist(elem);
        elem.toggleClass('products-show');
        return false;
      });
      t.on("click", function (ev) {
        var $trigger = $(".wlfmc-products-counter-wrapper.show-list-on-click .wlfmc-products-counter.has-dropdown");

        if ($trigger !== ev.target && !$trigger.has(ev.target).length) {
          $(".wlfmc-products-counter-dropdown").removeClass("products-show");
        }
      });
      t.on('mouseover', '.wlfmc-products-counter-wrapper.show-list-on-hover .wlfmc-products-counter.has-dropdown', function (ev) {
        ev.preventDefault();
        var elem = $(this).closest('.wlfmc-products-counter-wrapper').find('.wlfmc-products-counter-dropdown');
        prepare_mini_wishlist(elem);
        return false;
      });

      if ('ontouchstart' in window || navigator.maxTouchPoints > 0 || navigator.msMaxTouchPoints > 0) {
        t.on('click', '.wlfmc-products-counter-wrapper.show-list-on-hover .wlfmc-products-counter.has-dropdown', function (e) {
          if (!$(this).hasClass('wlfmc-first-click')) {
            e.preventDefault();
            $(this).addClass('wlfmc-first-click');
          }
        });
        var wlfmc_swipe_trigger;
        t.on('touchstart', '.wlfmc-products-counter-wrapper.show-list-on-hover', function (e) {
          wlfmc_swipe_trigger = false;
        });
        t.on('touchmove', '.wlfmc-products-counter-wrapper.show-list-on-hover', function (e) {
          wlfmc_swipe_trigger = true;
        });
        t.on('touchend', '.wlfmc-products-counter-wrapper.show-list-on-hover', function (e) {
          if ($(this).hasClass('wlfmc-first-touch')) {
            if (!wlfmc_swipe_trigger) {
              hide_mini_wishlist.call($('.wlfmc-products-counter-wrapper'), e);
            }
          } else {
            e.preventDefault();
            show_mini_wishlist.call(this, e);
            $(this).addClass('wlfmc-first-touch');
          }
        });
        t.on('touchend', ':not(.wlfmc-products-counter-wrapper.show-list-on-hover)', function (e) {
          if ($(e.target).closest('.wlfmc-products-counter-wrapper').length === 0) {
            hide_mini_wishlist.call($('.wlfmc-products-counter-wrapper'), e);
          }
        });
      } else {
        $('.wlfmc-products-counter-wrapper.show-list-on-hover .wlfmc-products-counter.has-dropdown').hoverIntent({
          interval: 0,
          timeout: 100,
          over: show_mini_wishlist,
          out: hide_mini_wishlist
        });
      }

      init_prepare_qty_links();
      init_wishlist_popup();
      init_quantity();
      init_checkbox_handling();
      init_copy_wishlist_link();
      init_tooltip();
    }).trigger('wlfmc_init'); // fix with jet woo builder plugin.

    $(document).on('jet-filter-content-rendered', reInit_wlfmc).on('jet-woo-builder-content-rendered', reInit_wlfmc).on('jet-engine/listing-grid/after-load-more', reInit_wlfmc).on('jet-engine/listing-grid/after-lazy-load', reInit_wlfmc).on('jet-cw-loaded', reInit_wlfmc);

    function init_prepare_qty_links() {
      var qty = document.querySelectorAll('.wlfmc-wishlist-table .quantity');

      if (qty.length < 1) {
        return false;
      }

      for (var i = 0; i < qty.length; i++) {
        if (qty[i].classList.contains('hidden')) {
          return false;
        }

        var plus = qty[i].querySelector('.botiga-quantity-plus, a.plus'),
            minus = qty[i].querySelector('.botiga-quantity-minus, a.minus');

        if (!plus || !minus || plus.length < 1 || minus.length < 1) {
          return false;
        }

        plus.classList.add('show');
        minus.classList.add('show');
        plus.addEventListener('click', function (e) {
          var input = this.parentNode.querySelector('.qty'),
              changeEvent = document.createEvent('HTMLEvents');
          e.preventDefault();
          input.value = input.value === '' ? 0 : parseInt(input.value) + 1;
          changeEvent.initEvent('change', true, false);
          input.dispatchEvent(changeEvent);
        });
        minus.addEventListener('click', function (e) {
          var input = this.parentNode.querySelector('.qty'),
              changeEvent = document.createEvent('HTMLEvents');
          e.preventDefault();
          input.value = parseInt(input.value) > 0 ? parseInt(input.value) - 1 : 0;
          changeEvent.initEvent('change', true, false);
          input.dispatchEvent(changeEvent);
        });
      }
    }

    function prepare_mini_wishlist(a) {
      var ao = a.offset(),
          al = ao.left,
          at = ao.top,
          aw = a.outerWidth(),
          ah = a.outerHeight(),
          la = parseFloat(a.css('left')),
          ta = parseFloat(a.css('top')),
          aol = al - la,
          aot = at - ta,
          _la = la,
          _ta = ta,
          ww = $(window).width(),
          dh = $(document).height(),
          os = 50,
          r = ww - aol - aw - os,
          l = os - aol,
          b = dh - aot - ah - os;

      if (ww <= aw) {
        _la = -1 * aol;
      } else if (0 > ww - (aw + os * 2)) {
        _la = (ww - aw) / 2 - aol;
      } else if (0 < l) {
        _la = l;
      } else if (0 > r) {
        _la = r;
      }

      if (dh < ah) {
        a.height(dh - a.outerHeight() + a.height());
        ah = a.outerHeight();
      }

      if (dh <= ah) {
        _ta = -1 * aot;
      } else if (0 > dh - (ah + os * 2)) {
        _ta = (dh - ah) / 2 - aot;
      } else if (0 > b) {
        _ta = b;
      }

      a.css({
        left: _la,
        top: _ta
      });
    }

    function show_mini_wishlist() {
      var elem = $(this).closest('.wlfmc-products-counter-wrapper').find('.wlfmc-products-counter-dropdown');
      prepare_mini_wishlist(elem);
      elem.addClass('products-show');
    }

    function hide_mini_wishlist() {
      var elem = $(this).closest('.wlfmc-products-counter-wrapper').find('.wlfmc-products-counter-dropdown');
      $('.wlfmc-first-touch').removeClass('wlfmc-first-touch');
      $('.wlfmc-first-click').removeClass('wlfmc-first-click');
      elem.removeClass('products-show');
    }

    function reInit_wlfmc() {
      $(document).trigger('wlfmc_init');
    }
    /* === Tooltip === */


    function init_tooltip() {
      var wlfmc_tooltip = function wlfmc_tooltip() {
        var instance;

        var _self = this;

        this.idSelector = 'wlfmc-tooltip';
        this.text = '';
        this.top = 0;
        this.left = 0;
        this.direction = typeof this.direction !== 'undefined' ? this.direction : 'bottom';
        this.t_type = typeof this.t_type !== 'undefined' ? this.t_type : 'default';
        this.target = ''; // Create actual element and tie element to object for reference.

        this.node = document.createElement("div");
        this.node.setAttribute("id", this.idSelector);
        this.node.className = this.node.className + "tooltip__hidden";
        this.node.innerHTML = this.text;
        document.body.appendChild(this.node);

        this.show = function () {
          // Rerender tooltip.
          var location_order = ['top', 'right', 'bottom', 'left'];
          _self.node.innerHTML = _self.text;
          var direction = _self.direction;
          var t_type = _self.t_type;

          if (direction) {
            $(this.node).addClass('tooltip__expanded tooltip__expanded-' + direction);
          } else {
            $(this.node).addClass('tooltip__expanded');
          }

          $(this.node).addClass('wlfmc-tooltip-' + t_type);
          $(this.node).removeClass('tooltip__hidden');

          if (offscreen($(wlfmcTooltip.node))) {
            wlfmcTooltip.hide();
            wlfmcTooltip.direction = location_order[location_order.indexOf(wlfmcTooltip.direction) + 1];
            moveTip(wlfmcTooltip.node, wlfmcTooltip.target);
          }
        };

        this.hide = function () {
          // Hide tooltip.
          $(_self.node).css('top', '0');
          $(_self.node).css('left', '0');
          $(_self.node).attr('class', '');
          $(_self.node).addClass('tooltip__hidden');
        };
      }; // Move tip to proper location before display.


      var offscreen = function offscreen(el) {
        return el.offsetLeft + el.offsetWidth < 0 || el.offsetTop + el.offsetHeight < 0 || el.offsetLeft + el.offsetWidth > window.innerWidth || el.offsetTop + el.offsetHeight > window.innerHeight;
      };

      var moveTip = function moveTip(ell, target) {
        var $target = $(target);
        var $ell = $(ell);
        var body = $("body").offset();
        $("body").css({
          'position': 'relative'
        }); // fix $ell size after change new tooltip text.

        wlfmcTooltip.show();
        wlfmcTooltip.hide();
        var buu = 7; // Default padding size in px.

        var center_height = -($ell.outerHeight() / 2) / 2;
        var center_width = -($ell.outerWidth() / 2) + $target.outerWidth() / 2;
        var locations = {
          'top': [-$ell.outerHeight() - buu, center_width],
          'right': [center_height, $target.outerWidth() + buu],
          'bottom': [$target.outerHeight() + buu, center_width],
          'left': [center_height, -$ell.outerWidth() - buu]
        };
        var location_order = ['top', 'right', 'bottom', 'left'];
        var location_keys = Object.keys(locations);

        if (wlfmcTooltip.direction === 'top' || wlfmcTooltip.direction === 'bottom') {
          $ell.css('top', $target.offset().top - body.top + locations[wlfmcTooltip.direction][0]);
          $ell.css('left', $target.offset().left - body.left + buu / 2 + locations[wlfmcTooltip.direction][1]);
        } else {
          $ell.css('top', $target.offset().top - body.top + buu / 2 + locations[wlfmcTooltip.direction][0]);
          $ell.css('left', $target.offset().left - body.left + locations[wlfmcTooltip.direction][1]);
        }

        if (offscreen($ell)) {
          wlfmcTooltip.direction = location_order[location_order.indexOf(wlfmcTooltip.direction) + 1];
          wlfmcTooltip.show();
        } else {
          wlfmcTooltip.show();
        }
      }; // Create global wlfmc_tooltip.


      var wlfmcTooltip = new wlfmc_tooltip(); // Mouseover to show.

      $(".wlfmc-tooltip").on("mouseover", function (ee) {
        var _self = this;

        wlfmcTooltip.target = _self; // Default to self.

        var name_classes = _self.className.split(' ');

        name_classes.forEach(function (cc) {
          if (cc.indexOf('wlfmc-tooltip-') != -1) {
            // Find a directional tag.
            wlfmcTooltip.direction = cc.split('-')[cc.split('-').length - 1];
          }
        });

        if ($(this).attr('data-tooltip-type')) {
          wlfmcTooltip.t_type = $(this).attr('data-tooltip-type');
        }

        if ($(this).attr('data-tooltip-text')) {
          wlfmcTooltip.text = $(this).attr('data-tooltip-text');
          moveTip(wlfmcTooltip.node, wlfmcTooltip.target);
        }
      });
      $('.wlfmc-tooltip').on("mouseout", function (ee) {
        // Re-hide tooltip.
        wlfmcTooltip.hide();
      });
    }

    function init_fix_on_image_single_position() {
      if ($('.woocommerce-product-gallery__wrapper .wlfmc-top-of-image').length > 0) {
        $('.woocommerce-product-gallery__wrapper .wlfmc-top-of-image').each(function () {
          $(this).insertAfter($(this).parent());
        });
      }
    }
    /* === INIT FUNCTIONS === */

    /**
     * Init popup for all links with the plugin that open a popup
     *
     * @return void
     */


    function init_wishlist_popup() {
      // add & remove class to body when popup is opened.
      var callback = function callback(node, op) {
        if (typeof node.classList !== 'undefined' && node.classList.contains('wlfmc-overlay')) {
          var method = 'remove' === op ? 'removeClass' : 'addClass';
          $('body')[method]('wlfmc-with-popup');
        }
      },
          callbackAdd = function callbackAdd(node) {
        callback(node, 'add');
      },
          callbackRemove = function callbackRemove(node) {
        callback(node, 'remove');
      },
          observer = new MutationObserver(function (mutationsList) {
        for (var i in mutationsList) {
          var mutation = mutationsList[i];

          if (mutation.type === 'childList') {
            if (typeof mutation.addedNodes !== 'undefined') {
              mutation.addedNodes.forEach(callbackAdd);
            }

            if (typeof mutation.removedNodes !== 'undefined') {
              mutation.removedNodes.forEach(callbackRemove);
            }
          }
        }
      });

      observer.observe(document.body, {
        childList: true
      });
    }
    /**
     * Init checkbox handling
     *
     * @return void
     */


    function init_checkbox_handling() {
      var checkboxes = $('.wlfmc-wishlist-table').find('.product-checkbox input[type="checkbox"]');
      checkboxes.off('change').on('change', function (e) {
        e.preventDefault();
        var t = $(this),
            p = t.parent();

        if (!t.is(':checked')) {
          $('input[name="' + t.attr('name') + '"]').prop('checked', false);
          $('#bulk_add_to_cart').prop('checked', false);
        }

        p.removeClass('checked').removeClass('unchecked').addClass(t.is(':checked') ? 'checked' : 'unchecked');
        return false;
      }).trigger('change');
    }
    /**
     * Init js handling on wishlist table items after ajax update
     *
     * @return void
     */


    function init_handling_after_ajax() {
      init_checkbox_handling();
      init_quantity();
      init_copy_wishlist_link();
      init_tooltip();
      $(document).trigger('wlfmc_init_after_ajax');
    }
    /**
     * Handle quantity input change for each wishlist item
     *
     * @return void
     */


    function init_quantity() {
      var jqxhr, timeout;
      $('.wlfmc-wishlist-table').on('change', '.quantity :input', function () {
        var t = $(this),
            row = t.closest('[data-row-id]'),
            product_id = row.data('row-id'),
            table = t.closest('.wlfmc-wishlist-table'),
            token = table.data('token');
        clearTimeout(timeout); // set add to cart link to add specific qty to cart.

        row.find('.add_to_cart_button').attr('data-quantity', t.val());
        timeout = setTimeout(function () {
          if (jqxhr) {
            jqxhr.abort();
          }

          jqxhr = $.ajax({
            beforeSend: function beforeSend(xhr) {
              if (wlfmc_l10n.ajax_mode === 'rest_api') {
                xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
              }

              block(row);
            },
            complete: function complete() {
              unblock(row);
            },
            data: {
              action: wlfmc_l10n.actions.update_item_quantity,
              context: 'frontend',
              product_id: product_id,
              wishlist_token: token,
              quantity: t.val()
            },
            method: 'POST',
            url: wlfmc_l10n.ajax_url
          });
        }, 1000);
      });
    }
    /**
     * Init handling for copy button
     *
     * @return void
     */


    function init_copy_wishlist_link() {
      $('.copy-link-trigger').on('click', function (e) {
        e.preventDefault();
        var obj_to_copy = $(this);
        var hidden = $('<input/>', {
          val: obj_to_copy.attr('href'),
          type: 'text'
        });
        $('body').append(hidden);

        if (isOS()) {
          hidden[0].setSelectionRange(0, 9999);
        } else {
          hidden.select();
        }

        document.execCommand('copy');
        hidden.remove();
        toastr.success(wlfmc_l10n.labels.link_copied);
        return false;
      });
    }
    /* === EVENT HANDLING === */


    function load_analytics(product_id, wishlist_id) {
      $.ajax({
        beforeSend: function beforeSend(xhr) {
          if (wlfmc_l10n.ajax_mode === 'rest_api') {
            xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
          }
        },
        complete: function complete() {// anything.
        },
        data: {
          action: wlfmc_l10n.actions.load_analytics,
          context: 'frontend',
          product_id: product_id,
          wishlist_id: wishlist_id
        },
        method: 'POST',
        url: wlfmc_l10n.ajax_url
      });
    }
    /* === UTILS === */

    /**
     * Block item if possible
     *
     * @param item jQuery object
     * @return void
     */


    function block(item) {
      if (typeof $.fn.block !== 'undefined' && wlfmc_l10n.enable_ajax_loading) {
        item.fadeTo('400', '0.6').block({
          message: null,
          overlayCSS: {
            backgroundColor: 'rgba(255,255,255,0.5)',
            backgroundImage: 'url(' + wlfmc_l10n.ajax_loader_url + ')',
            backgroundRepeat: 'no-repeat',
            backgroundPosition: 'center',
            backgroundSize: '40px 40px',
            opacity: 1
          }
        });
      }
    }
    /**
     * Unblock item if possible
     *
     * @param item jQuery object
     * @return void
     */


    function unblock(item) {
      if (typeof $.fn.unblock !== 'undefined') {
        item.stop(true).css('opacity', '1').unblock();
        $('.tooltip__expanded').removeClass().addClass('tooltip__hidden');
      }
    }
    /**
     * Check if cookies are enabled
     *
     * @return bool
     */


    function is_cookie_enabled() {
      if (navigator.cookieEnabled) {
        return true;
      } // set and read cookie.


      document.cookie = 'cookietest=1';
      var ret = document.cookie.indexOf('cookietest=') !== -1; // delete cookie.

      document.cookie = 'cookietest=1; expires=Thu, 01-Jan-1970 00:00:01 GMT';
      return ret;
    }
    /**
     * Retrieve fragments that need to be refreshed in the page
     *
     * @param search string Ref to search among all fragments in the page
     * @return object Object containing a property for each fragment that matches search
     */


    function retrieve_fragments(search) {
      var options = {},
          fragments = null;

      if (search) {
        if (_typeof2(search) === 'object') {
          search = $.extend({
            fragments: null,
            s: '',
            container: $(document),
            firstLoad: false
          }, search);

          if (!search.fragments) {
            fragments = search.container.find('.wlfmc-wishlist-fragment');
          } else {
            fragments = search.fragments;
          }

          if (search.s) {
            fragments = fragments.not('[data-fragment-ref]').add(fragments.filter('[data-fragment-ref="' + search.s + '"]'));
          }

          if (search.firstLoad) {
            fragments = fragments.filter('.on-first-load');
          }
        } else {
          fragments = $('.wlfmc-wishlist-fragment');

          if (typeof search === 'string' || typeof search === 'number') {
            fragments = fragments.not('[data-fragment-ref]').add(fragments.filter('[data-fragment-ref="' + search + '"]'));
          }
        }
      } else {
        fragments = $('.wlfmc-wishlist-fragment');
      }

      if (fragments.length) {
        fragments.each(function () {
          var t = $(this),
              id = t.attr('class').split(' ').filter(function (val) {
            return val.length && val !== 'exists';
          }).join(wlfmc_l10n.fragments_index_glue);
          options[id] = t.data('fragment-options');
        });
      } else {
        return null;
      }

      return options;
    }
    /**
     * Load fragments on page loading
     *
     * @param search string Ref to search among all fragments in the page
     */


    function load_fragments(search) {
      search = $.extend({
        firstLoad: true
      }, search);
      var fragments = retrieve_fragments(search);

      if (!fragments) {
        return;
      }

      $.ajax({
        data: {
          action: wlfmc_l10n.actions.load_fragments,
          context: 'frontend',
          fragments: fragments
        },
        method: 'post',
        beforeSend: function beforeSend(xhr) {
          if (wlfmc_l10n.ajax_mode === 'rest_api') {
            xhr.setRequestHeader('X-WP-Nonce', wlfmc_l10n.nonce);
          }
        },
        success: function success(data) {
          if (typeof data.fragments !== 'undefined') {
            replace_fragments(data.fragments);
            init_handling_after_ajax();
            $(document).trigger('wlfmc_fragments_loaded', [fragments, data.fragments, search.firstLoad]);
          }

          if (typeof data.products !== 'undefined') {
            set_products_hash(JSON.stringify(data.products));
          }

          if (typeof data.lang !== 'undefined') {
            set_lang_hash(data.lang);
          }
        },
        url: wlfmc_l10n.ajax_url
      });
    }
    /**
     * Replace fragments with template received
     *
     * @param fragments array Array of fragments to replace
     */


    function replace_fragments(fragments) {
      $.each(fragments, function (i, v) {
        var itemSelector = '.' + i.split(wlfmc_l10n.fragments_index_glue).filter(function (val) {
          return val.length && val !== 'exists' && val !== 'with-count';
        }).join('.'),
            toReplace = $(itemSelector); // find replace template.

        var replaceWith = $(v).filter(itemSelector);

        if (!replaceWith.length) {
          replaceWith = $(v).find(itemSelector);
        }

        if (toReplace.length && replaceWith.length) {
          toReplace.replaceWith(replaceWith);
        }
      });
    }
    /**
     * Check if device is an IOS device
     */


    function isOS() {
      return navigator.userAgent.match(/ipad|iphone/i);
    }
    /**
     * Check if passed value could be considered true
     */


    function isTrue(value) {
      return true === value || 'yes' === value || '1' === value || 1 === value;
    }

    function check_products(products) {
      if (null !== products) {
        product_in_list = [];
        var counter_items = $('.wlfmc-products-counter-wrapper .wlfmc-counter-item');

        if (counter_items.length && product_in_list.length) {
          counter_items.each(function () {
            var p_id = $(this).attr('data-row-id');

            if (!$.grep(product_in_list, function (item) {
              return item.product_id === p_id;
            }).length) {
              $('.wlfmc-products-counter-wrapper').find('[data-row-id="' + p_id + '"]').remove();
            }
          });
        }

        var table_items = $('.wlfmc-wishlist-form .wlfmc-table-item');

        if (table_items.length && product_in_list.length) {
          table_items.each(function () {
            var p_id = $(this).attr('data-row-id');

            if (!$.grep(product_in_list, function (item) {
              return item.product_id === p_id;
            }).length) {
              $('.wlfmc-wishlist-form').find('[data-row-id="' + p_id + '"]').remove();
            }
          });
        }

        $('.wlfmc-add-to-wishlist').removeClass('exists');
        $.each(products, function (id, itemData) {
          var same_products = $('.wlfmc-add-to-wishlist-' + itemData.product_id);
          same_products.each(function () {
            $(this).addClass('exists');
            $(this).find('.wlfmc_delete_item').attr('data-item-id', itemData.item_id);
            $(this).find('.wlfmc_delete_item').attr('data-wishlist-id', itemData.wishlist_id);
          });
          $('.wlfmc-products-counter-wrapper  .products-counter-number').text(itemData.length);
          $('.wlfmc-products-counter-wishlist .total-products .wlfmc-total-count').text(itemData.length);
          product_in_list.push(itemData);
        });
      }
    }
    /* Storage Handling */


    var $supports_html5_storage = true,
        wishlist_hash_key = wlfmc_l10n.wishlist_hash_key,
        products_hash_key = wishlist_hash_key + '_products',
        lang_hash_key = wishlist_hash_key + '_lang';

    try {
      $supports_html5_storage = 'sessionStorage' in window && window.sessionStorage !== null;
      window.sessionStorage.setItem('wlfmc', 'test');
      window.sessionStorage.removeItem('wlfmc');
      window.localStorage.setItem('wlfmc', 'test');
      window.localStorage.removeItem('wlfmc');
    } catch (err) {
      $supports_html5_storage = false;
    }
    /** Set the wishlist hash in both session and local storage */


    function set_products_hash(products) {
      if ($supports_html5_storage) {
        localStorage.setItem(products_hash_key, products);
        sessionStorage.setItem(products_hash_key, products);
      }

      check_products(JSON.parse(products));
    }

    function set_lang_hash(lang) {
      if ($supports_html5_storage) {
        localStorage.setItem(lang_hash_key, lang);
        sessionStorage.setItem(lang_hash_key, lang);
      }
    }
    /* Wishlist Handling */


    if ($supports_html5_storage) {
      // Refresh when storage changes in another tab.
      $(window).on('storage onstorage', function (e) {
        if (products_hash_key === e.originalEvent.key && localStorage.getItem(products_hash_key) !== sessionStorage.getItem(products_hash_key)) {
          load_fragments();
        }
      }); // Refresh when page is shown after back button (safari).

      $(window).on('pageshow', function (e) {
        if (e.originalEvent.persisted) {
          load_fragments();
        }
      });

      try {
        if (wlfmc_l10n.is_cache_enabled) {
          throw 'Need Update wishlist data';
        }

        if (wlfmc_l10n.update_wishlists_data || null !== lang && lang !== localStorage.getItem(lang_hash_key) || localStorage.getItem(products_hash_key) !== JSON.stringify(wishlist_items)) {
          localStorage.setItem(products_hash_key, '');
          localStorage.setItem(lang_hash_key, '');
          check_products(wishlist_items);
          throw 'Need Update wishlist data';
        }

        if (localStorage.getItem(products_hash_key)) {
          var data = JSON.parse(localStorage.getItem(products_hash_key));

          if ('object' === _typeof(data) && null !== data) {
            check_products(data);
          }
        }
      } catch (err) {
        console.log(err);
        load_fragments();
      }
    } else {
      load_fragments();
    } // Customer support.


    var hasSelectiveRefresh = 'undefined' !== typeof wp && wp.customize && wp.customize.selectiveRefresh && wp.customize.widgetsPreview && wp.customize.widgetsPreview.WidgetPartial;

    if (hasSelectiveRefresh) {
      wp.customize.selectiveRefresh.bind('partial-content-rendered', function () {
        load_fragments();
      });
    }
  });
})(jQuery);