<?php
/**
 * WLFMC wishlist integration with divi theme
 *
 * @author MoreConvert
 * @package Smart Wishlist For More Convert
 * @version 1.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

add_action( 'init', 'wlfmc_divi_integrate' );

/**
 * Integration with Divi theme
 *
 * @return void
 */
function wlfmc_divi_integrate() {

	if ( function_exists( 'et_setup_theme' ) ) {

		add_filter( 'wlfmc_loop_positions', 'wlfmc_divi_fix_loop_position' );

	}

}

/**
 * Fix loop position
 *
 * @param array $positions all loop positions.
 *
 * @return array
 */
function wlfmc_divi_fix_loop_position( array $positions ): array {

	$positions['image_top_left']['hook']  = 'woocommerce_after_shop_loop_item';
	$positions['image_top_right']['hook'] = 'woocommerce_after_shop_loop_item';

	return $positions;
}

