<?php
/**
 * Wishlist Counter empty guests template;
 *
 * @author MoreConvert
 * @package Smart Wishlist For More Convert
 * @version 1.4.0
 */

/**
 * Template Variables:
 *
 * @var $atts                       array all template variables
 * @var $show_icon                  bool show icon
 * @var $show_text                  bool show text
 * @var $show_empty_content         bool show empty message if no product in the wishlist
 * @var $dropdown_products          bool show product as dropdown
 * @var $fragment_options           array Array of items to use for fragment generation
 * @var $counter_text               string Current page
 * @var $icon                       html counter icon
 * @var $add_link_title             bool add line for title of counter  if not showing product list
 * @var $wishlist_link_position     string after/before product list
 * @var $is_svg_icon                bool Whether  icon is svg
 * @var $empty_wishlist_content     string string of no product in wishlist
 * @var $show_list_on_hover         bool show product lis on hover or after clicked
 * @var $container_class            string Container class
 */


if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
?>
<div class="wlfmc-products-counter-wrapper <?php echo esc_attr( $container_class ); ?> <?php echo $show_list_on_hover ? 'show-list-on-hover' : 'show-list-on-click'; ?>  woocommerce wlfmc-wishlist-fragment on-first-load"
	data-fragment-options="<?php echo esc_attr( wp_json_encode( $fragment_options ) ); ?>">
	<?php if ( $show_icon || $show_text ) : ?>
		<a href="#" class="wlfmc-products-counter <?php echo $dropdown_products ? 'has-dropdown' : ''; ?>">
			<?php if ( $show_icon ) : ?>
				<span class="wlfmc-counter-icon">
					<?php echo $is_svg_icon ? '<i class="wlfmc-svg">' . wlfmc_sanitize_svg( $icon ) . '</i>' : wp_kses_post( $icon );// phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
				</span>
			<?php endif; ?>

			<?php if ( $show_text ) : ?>
				<span class="wishlist-products-counter-text"><?php echo wp_kses_post( $counter_text ); ?></span>
			<?php endif; ?>

		</a>
	<?php endif; ?>
	<?php if ( $show_empty_content ) : ?>
		<div class="wlfmc-products-counter-wishlist <?php echo $dropdown_products ? 'wlfmc-products-counter-dropdown' : ''; ?>">
			<div class="wlfmc-wishlist-content d-flex flex-column gap-10">
				<div class="wlfmc-wishlist-empty"><?php echo wp_kses_post( apply_filters( 'wlfmc_no_product_in_wishlist_message', $empty_wishlist_content, null ) ); ?></div>
			</div>
		</div>
	<?php endif; ?>
</div>
